#!/usr/bin/perl -w

package KartaAdresare;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gnome2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;
use lib::Seznam;
use lib::KartaKontaktniOsoby;

my $MyUI;
my %MyMoney;
my $retcode="";
my $KartaAdresare;
my $Locks;
my $in_init=0;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('a_AdresarF',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    $Locks=0;
    %MyMoney=%params;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self,$skupina_id, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    $self->{'skupina_id'}=$skupina_id;
    my $retval=$self->run(0,'',0,%params);
    $self->{'skupina_id'}=0;
    return($retval);
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('a_AdresarF',$where,1)) {
        return(0);
    };
    $KartaAdresare=new Table('a_AdresarF',%MyMoney);
    $KartaAdresare->load($where);
    my $Databaze=new Databaze(%MyMoney);    
    if(!$Databaze->Remove("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    #
    # smazat osoby ve firme
    #
    $Databaze->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO","firma_id='".$KartaAdresare->get('id')."'");
    if($Databaze->numrows) {
        if(!$Databaze->Remove("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO","firma_id='".$KartaAdresare->get('id')."'")) {
            $Locks->remove_lock;
            return(0);
        };
    };
    $Locks->remove_lock;
    return(1);
};

my @SeznamOsob=();
sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    my $window=$class;
    $MyUI=$class;
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox258'};
    $MyUI->{'dissable_ok'}=$dissable_ok;
    $KartaAdresare=new Table('a_AdresarF',%MyMoney);
    @SeznamOsob=();
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };
    if($where) {
        if(!$KartaAdresare->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    } else {
        $KartaAdresare->set('skupina_id',$MyUI->{'skupina_id'});
    };

    $MyUI->FORM->{'list_osoby'}=Gtk2::SimpleList->new('Prijmeni'=>'text','Jmeno'=>'text','Kod partnera (EAN)'=>'text','Funkce'=>'text','Ulice'=>'text','Mesto'=>'text','PSC'=>'text','Stat'=>'text','Tel. pred.'=>'text','Tel.'=>'text','Tel. klap.'=>'text','Fax pred.'=>'text','Fax'=>'text','Fax klap.'=>'text','E-mail'=>'text','Mobil pred.'=>'text','Mobil'=>'text','Cislo'=>'int','Poradi'=>'int');
    #$MyUI->FORM->{'list_osoby'}->set_events(['button_press_mask']);
    #$MyUI->FORM->{'list_osoby'}->signal_connect("button_press_event","list_osoby_menu_activate");
    $MyUI->FORM->{'list_osoby'}->set_headers_visible('1');
    $MyUI->FORM->{'scrolledwindow_osoby'}->add($MyUI->FORM->{'list_osoby'});
    $MyUI->FORM->{'list_osoby'}->show;
    $MyUI->FORM->{'list_osoby'}->set_enable_search('1');
    $MyUI->FORM->{'list_osoby'}->set_reorderable('0');
    $MyUI->FORM->{'list_osoby'}->set_rules_hint('1');
    $MyUI->FORM->{'list_osoby'}->columns_autosize;
    $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('multiple');
    $MyUI->FORM->{'list_osoby'}->signal_connect("row-activated"=>"upravit_osobu");
    $MyUI->FORM->{'list_osoby'}->get_selection->signal_connect("changed"=>"osoby_selection_changed");
    my $i=0;
    foreach my $column ($MyUI->FORM->{'list_osoby'}->get_columns) {
        $column->set_resizable(1);
        $column->set_clickable(1);
        $column->set_sort_indicator(0);
        $column->set_sort_column_id($i);
        $column->set_min_width(10);
        $i++;
    };

    #
    # nacteni jmena skupiny
    #
    my $Skupina=new Table('a_AdrSkup',%MyMoney);
    if($KartaAdresare->get('skupina_id')) {
        $Skupina->load("id='".$KartaAdresare->get('skupina_id')."'");
    };
    $MyUI->FORM->{'skupina_nazev'}->set_text($Skupina->get('nazev'));
    
    #
    # nacteni seznamu osob
    #
    if($where) {
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO","firma_id='".$KartaAdresare->get('id')."'","id");
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            my %row=$Databaze->fetchhash;
            my $Osoba=new Table('a_AdresarO',%MyMoney);
            $Osoba->load("id='".$row{'id'}."'");
            if($kopie) {
                $Osoba->set('id',0);
                $Osoba->set('firma_id',0);
            };
            $Osoba->set('poradi',$i+1);
            push(@SeznamOsob,$Osoba);
        };
    };

    
    foreach my $Osoba (@SeznamOsob) {
        push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$Osoba->get("prijmeni"),$Osoba->get("jmeno"),$Osoba->get("ean"),$Osoba->get("funkce"),$Osoba->get("ulice"),$Osoba->get("mesto"),$Osoba->get("psc"),$Osoba->get("statnazev"),$Osoba->get("telpred"),$Osoba->get("tel"),$Osoba->get("telklap"),$Osoba->get("faxpred"),$Osoba->get("fax"),$Osoba->get("faxklap"),$Osoba->get("email"),$Osoba->get("mobilpred"),$Osoba->get("mobil"),$Osoba->get("id"),$Osoba->get("poradi")]);
    };
    $in_init=1;
    $KartaAdresare->WriteToUI($window->FORM);
    $in_init=0;
    $MyUI->on_provadr_zobch_toggled;
    $MyUI->on_fakadr_zprov_toggled;
    $MyUI->on_email_changed;
    $MyUI->on_www_changed;
    $MyUI->on_pouzit_slevu_toggled;
    $MyUI->on_pouzit_kredit_toggled;
    $MyUI->on_pouzit_splpoh_toggled;
    $MyUI->on_pouzit_splzav_toggled;
    $MyUI->osoby_selection_changed;
    
    if(@SeznamOsob!=1) {
        $MyUI->FORM->{'firmajeosoba'}->set_active(0);
        $MyUI->FORM->{'firmajeosoba'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'firmajeosoba'}->set_sensitive(1);
    };

    
    $window->TOPLEVEL->set_title('Karta adresare');
    $MyMoney{'MainCfg'}->window_open("KartaAdresare",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaAdresare",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_KartaAdresare_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaAdresare",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $KartaAdresare->ReadFromUI($MyUI->FORM);
    if(!$KartaAdresare->get('ob_nazev')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Nazev nemuze byt prazdny!","type"=>"error");
            return;        
    };
    
    #
    # Tady zacne lokalni transakce
    #
    
    #
    # jeste je potreba zkontrolovat existenci zvolene adresni skupiny!
    #
    if($MyUI->{'where'}) {
        if(!$KartaAdresare->update) {
            return;
        };
        if(@SeznamOsob) {
            #
            # odstranit smazane osoby
            #
            my $soucasneosoby_ids="";
            foreach my $Osoba (@SeznamOsob) {
                if($Osoba->get('id') ne '0') {
                    if($soucasneosoby_ids) {
                        $soucasneosoby_ids.=",";
                    };
                    $soucasneosoby_ids.="'".$Osoba->get('id')."'";
                };
            };
            if($soucasneosoby_ids) {
                my $Databaze=new Databaze(%MyMoney);
                $Databaze->Remove("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO","firma_id='".$KartaAdresare->get('id')."' AND id NOT IN (".$soucasneosoby_ids.")");
            };
            
            #
            # aktualizovat seznam osob
            #
            foreach my $Osoba (@SeznamOsob) {
                if($Osoba->get('id') ne '0') {
                    my $poradi=$Osoba->get('poradi');
                    $Osoba->unset('poradi');
                    if(!$Osoba->update) {
                        $Osoba->set('poradi',$poradi);
                        return;
                    };
                    $Osoba->set('poradi',$poradi);
                } else {
                    my $poradi=$Osoba->get('poradi');
                    $Osoba->unset('poradi');
                    $Osoba->set('firma_id',$KartaAdresare->get('id'));
                    if(!$Osoba->save(1)) {
                        $Osoba->set('poradi',$poradi);
                        my $Dialog=new Dialog(%MyMoney);
                        $Dialog->show("text"=>"Záznam kontaktni osoby nelze uložit!","type"=>"error");
                        return;
                    };
                    $Osoba->set('poradi',$poradi);
                };
            };
        } else {
            my $Databaze=new Databaze(%MyMoney);
            $Databaze->Remove("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO","firma_id='".$KartaAdresare->get('id')."'");
        };
    } else {
        if(!$KartaAdresare->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!","type"=>"error");
            return;
        };
        
        #
        # ulozit seznam osob
        #
        foreach my $Osoba (@SeznamOsob) {
            my $poradi=$Osoba->get('poradi');
            $Osoba->unset('poradi');
            $Osoba->set('firma_id',$KartaAdresare->get('id'));
            if(!$Osoba->save(1)) {
                $Osoba->set('poradi',$poradi);
                my $Dialog=new Dialog(%MyMoney);
                $Dialog->show("text"=>"Záznam kontaktni osoby nelze uložit!","type"=>"error");
                return;
            };
            $Osoba->set('poradi',$poradi);
        };
    };
    #
    #
    # Tady je konec lokalni transakce
    #
    
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("KartaAdresare",$MyUI->TOPLEVEL);
    $retcode=$KartaAdresare;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_zobchjmena_clicked {
    $MyUI->FORM->{'pr_nazev'}->set_text($MyUI->FORM->{'ob_nazev'}->get_text);
    $MyUI->FORM->{'pr_ulice'}->set_text($MyUI->FORM->{'ob_ulice'}->get_text);
    $MyUI->FORM->{'pr_psc'}->set_text($MyUI->FORM->{'ob_psc'}->get_text);
    $MyUI->FORM->{'pr_mesto'}->set_text($MyUI->FORM->{'ob_mesto'}->get_text);
    $MyUI->FORM->{'pr_statnazev'}->set_text($MyUI->FORM->{'ob_statnazev'}->get_text);
    $MyUI->FORM->{'pr_statzkrat'}->set_text($MyUI->FORM->{'ob_statzkrat'}->get_text);
};

sub on_provadr_zobch_toggled {
    if($in_init) {
        return;
    };
    if($MyUI->FORM->{'provadr_zobch'}->get_active) {
        $MyUI->FORM->{'pr_nazev'}->set_sensitive(0);
        $MyUI->FORM->{'pr_ulice'}->set_sensitive(0);
        $MyUI->FORM->{'pr_psc'}->set_sensitive(0);
        $MyUI->FORM->{'pr_mesto'}->set_sensitive(0);
        $MyUI->FORM->{'button_prpsc'}->set_sensitive(0);
        $MyUI->FORM->{'pr_statnazev'}->set_sensitive(0);
        $MyUI->FORM->{'pr_statzkrat'}->set_sensitive(0);
        $MyUI->FORM->{'button_prstat'}->set_sensitive(0);
        $MyUI->FORM->{'button_zobchjmena'}->hide;
        $MyUI->on_button_zobchjmena_clicked;
    } else {
        $MyUI->FORM->{'pr_nazev'}->set_sensitive(1);
        $MyUI->FORM->{'pr_ulice'}->set_sensitive(1);
        $MyUI->FORM->{'pr_psc'}->set_sensitive(1);
        $MyUI->FORM->{'pr_mesto'}->set_sensitive(1);
        $MyUI->FORM->{'button_prpsc'}->set_sensitive(1);
        $MyUI->FORM->{'pr_statnazev'}->set_sensitive(1);
        $MyUI->FORM->{'pr_statzkrat'}->set_sensitive(1);
        $MyUI->FORM->{'button_prstat'}->set_sensitive(1);
        $MyUI->FORM->{'button_zobchjmena'}->show;
    };
};

sub obadr_changed {
    if($in_init) {
        return;
    };
    if($MyUI->FORM->{'provadr_zobch'}->get_active) {
        $MyUI->on_button_zobchjmena_clicked;
    };
};

sub on_button_zprovozovny_clicked {
    $MyUI->FORM->{'fa_nazev'}->set_text($MyUI->FORM->{'pr_nazev'}->get_text);
    $MyUI->FORM->{'fa_ulice'}->set_text($MyUI->FORM->{'pr_ulice'}->get_text);
    $MyUI->FORM->{'fa_psc'}->set_text($MyUI->FORM->{'pr_psc'}->get_text);
    $MyUI->FORM->{'fa_mesto'}->set_text($MyUI->FORM->{'pr_mesto'}->get_text);
    $MyUI->FORM->{'fa_statnazev'}->set_text($MyUI->FORM->{'pr_statnazev'}->get_text);
    $MyUI->FORM->{'fa_statzkrat'}->set_text($MyUI->FORM->{'pr_statzkrat'}->get_text);
};

sub on_fakadr_zprov_toggled {
    if($in_init) {
        return;
    };
    if($MyUI->FORM->{'fakadr_zprov'}->get_active) {
        $MyUI->FORM->{'fa_nazev'}->set_sensitive(0);
        $MyUI->FORM->{'fa_ulice'}->set_sensitive(0);
        $MyUI->FORM->{'fa_psc'}->set_sensitive(0);
        $MyUI->FORM->{'fa_mesto'}->set_sensitive(0);
        $MyUI->FORM->{'button_fapsc'}->set_sensitive(0);
        $MyUI->FORM->{'fa_statnazev'}->set_sensitive(0);
        $MyUI->FORM->{'fa_statzkrat'}->set_sensitive(0);
        $MyUI->FORM->{'button_fastat'}->set_sensitive(0);
        $MyUI->FORM->{'button_zprovozovny'}->hide;
        $MyUI->on_button_zprovozovny_clicked;
    } else {
        $MyUI->FORM->{'fa_nazev'}->set_sensitive(1);
        $MyUI->FORM->{'fa_ulice'}->set_sensitive(1);
        $MyUI->FORM->{'fa_psc'}->set_sensitive(1);
        $MyUI->FORM->{'fa_mesto'}->set_sensitive(1);
        $MyUI->FORM->{'button_fapsc'}->set_sensitive(1);
        $MyUI->FORM->{'fa_statnazev'}->set_sensitive(1);
        $MyUI->FORM->{'fa_statzkrat'}->set_sensitive(1);
        $MyUI->FORM->{'button_fastat'}->set_sensitive(1);
        $MyUI->FORM->{'button_zprovozovny'}->show;
    };
};

sub provadr_changed {
    if($in_init) {
        return;
    };
    if($MyUI->FORM->{'fakadr_zprov'}->get_active) {
        $MyUI->on_button_zprovozovny_clicked;
    };
};

sub on_email_changed {
    if($MyUI->FORM->{'email'}->get_text) {
        $MyUI->FORM->{'button_email'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'button_email'}->set_sensitive(0);
    };
};

sub on_www_changed {
    if($MyUI->FORM->{'www'}->get_text) {
        $MyUI->FORM->{'button_www'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'button_www'}->set_sensitive(0);
    };
};

sub on_button_email_clicked {
    my $button=Gnome2::HRef->new ("mailto:".$MyUI->FORM->{'email'}->get_text, "send email");
    $button->clicked;
};

sub on_button_www_clicked {
    my $button=Gnome2::HRef->new ("http://".$MyUI->FORM->{'www'}->get_text, "send email");
    $button->clicked;
};

sub on_pouzit_slevu_toggled {
    if($MyUI->FORM->{'pouzit_slevu'}->get_active) {
        $MyUI->FORM->{'sleva'}->set_sensitive(1);
        $MyUI->FORM->{'label1046'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'sleva'}->set_sensitive(0);
        $MyUI->FORM->{'label1046'}->set_sensitive(0);
    };
};

sub on_pouzit_kredit_toggled {
    if($MyUI->FORM->{'pouzit_kredit'}->get_active) {
        $MyUI->FORM->{'kredit'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'kredit'}->set_sensitive(0);
    };
};

sub on_pouzit_splpoh_toggled {
    if($MyUI->FORM->{'pouzit_splpoh'}->get_active) {
        $MyUI->FORM->{'spl_poh'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'spl_poh'}->set_sensitive(0);
    };
};

sub on_pouzit_splzav_toggled {
    if($MyUI->FORM->{'pouzit_splzav'}->get_active) {
        $MyUI->FORM->{'spl_zav'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'spl_zav'}->set_sensitive(0);
    };
};

sub on_button_banky_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$MyUI->FORM->{'bkod'}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('Adresar_last_kodbanky');
    };
    if($Seznam->run('banky',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod",selected_rows=>[$select_row])) {
        my $tbl=new Table('g_Banky',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'bkod'}->set_text($tbl->get('kod'));
                $MyUI->FORM->{'bnazev'}->set_text($tbl->get('nazev'));
                $MyMoney{'MainCfg'}->set('Adresar_last_kodbanky',$tbl->get('kod'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'bkod'}->set_text('');
            $MyUI->FORM->{'bnazev'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_skupina_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $select_row=$KartaAdresare->get('skupina_id');
    if($Seznam->run('adresni_skupiny',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"id",selected_rows=>[$select_row])) {
        my $tbl=new Table('a_AdrSkup',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'skupina_nazev'}->set_text($tbl->get('nazev'));
                $KartaAdresare->set('skupina_id',$tbl->get('id'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'skupina_nazev'}->set_text('');
            $KartaAdresare->set('skupina_id',0);
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub stat_clicked {
    my($self,$zkrat,$nazev)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $select_row=$MyUI->FORM->{$zkrat}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('Adresar_last_statzkrat');
    };
    my $Seznam=new Seznam;
    if($Seznam->run('staty',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod","selected_rows"=>[$select_row])) {
        my $tbl=new Table('g_Staty',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$zkrat}->set_text($tbl->get('kod'));
                $MyUI->FORM->{$nazev}->set_text($tbl->get('popis'));
                $MyMoney{'MainCfg'}->set('Adresar_last_statzkrat',$tbl->get('kod'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$zkrat}->set_text('');
            $MyUI->FORM->{$nazev}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);    
};

sub on_button_obstat_clicked {
    $MyUI->stat_clicked('ob_statzkrat','ob_statnazev');
};

sub on_button_prstat_clicked {
    $MyUI->stat_clicked('pr_statzkrat','pr_statnazev');
};

sub on_button_fastat_clicked {
    $MyUI->stat_clicked('fa_statzkrat','fa_statnazev');
};

sub psc_clicked {
    my($self,$psc,$mesto)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $select_row=$MyUI->FORM->{$psc}->get_text;
    if(!$select_row) {
        $select_row=$MyMoney{'MainCfg'}->get('Adresar_last_psc');
    };
    my $Seznam=new Seznam;
    if($Seznam->run('psc',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod","selected_rows"=>[$select_row])) {
        my $tbl=new Table('g_Psc',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$psc}->set_text($tbl->get('psc'));
                $MyUI->FORM->{$mesto}->set_text($tbl->get('misto'));
                $MyMoney{'MainCfg'}->set('Adresar_last_psc',$tbl->get('psc'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$psc}->set_text('');
            $MyUI->FORM->{$mesto}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);    
};

sub on_button_obpsc_clicked {
    $MyUI->psc_clicked('ob_psc','ob_mesto');
};

sub on_button_prpsc_clicked {
    $MyUI->psc_clicked('pr_psc','pr_mesto');
};

sub on_button_fapsc_clicked {
    $MyUI->psc_clicked('fa_psc','fa_mesto');
};

sub upravit_osobu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
    my @path=$MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path[0]);
    my $id=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,17);
    my $poradi=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,18);
    my $retval=0;
    foreach my $Osoba (@SeznamOsob) {
        if($Osoba->get('poradi') eq $poradi) {
            $retval=$KartaKontaktniOsoby->upravit_novy(1,"id='".$id."'",$Osoba,%MyMoney);
        };
    };
    if($retval) {
        my $i=0;
        $retval->set('poradi',$poradi);
        foreach $_ ("prijmeni","jmeno","ean","funkce","ulice","mesto","psc","statnazev","telpred","tel","telklap","faxpred","fax","faxklap","email","mobilpred","mobil","id","poradi") {
            $MyUI->FORM->{'list_osoby'}->get_model->set($iter,$i,$retval->get($_));
            $i++;
        };
        foreach my $Osoba (@SeznamOsob) {
            if($Osoba->get('poradi') eq $poradi) {
                $Osoba=$retval;
            };
        };
        if($MyUI->FORM->{'firmajeosoba'}->get_active) {
            my $Osoba=$SeznamOsob[0];
            $MyUI->FORM->{'ob_nazev'}->set_text($Osoba->get('prijmeni')." ".$Osoba->get('jmeno'));
            $MyUI->FORM->{'ob_ulice'}->set_text($Osoba->get('ulice'));
            $MyUI->FORM->{'ob_psc'}->set_text($Osoba->get('psc'));
            $MyUI->FORM->{'ob_mesto'}->set_text($Osoba->get('mesto'));
            $MyUI->FORM->{'ob_statnazev'}->set_text($Osoba->get('statnazev'));
            $MyUI->FORM->{'ob_statzkrat'}->set_text($Osoba->get('statzkrat'));
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_pridat_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
    if(my $retval=$KartaKontaktniOsoby->pridat(1,$KartaAdresare->get('id'),%MyMoney)) {
        my $poradi=@SeznamOsob;
        $poradi++;
        $retval->set('poradi',$poradi);
        push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$retval->get("prijmeni"),$retval->get("jmeno"),$retval->get("ean"),$retval->get("funkce"),$retval->get("ulice"),$retval->get("mesto"),$retval->get("psc"),$retval->get("statnazev"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("mobilpred"),$retval->get("mobil"),$retval->get("id"),$retval->get("poradi")]);
        push(@SeznamOsob,$retval);
        if(@SeznamOsob!=1) {
            $MyUI->FORM->{'firmajeosoba'}->set_active(0);
            $MyUI->FORM->{'firmajeosoba'}->set_sensitive(0);
        } else {
            $MyUI->FORM->{'firmajeosoba'}->set_sensitive(1);
        };
        if($MyUI->FORM->{'firmajeosoba'}->get_active) {
            my $Osoba=$SeznamOsob[0];
            $MyUI->FORM->{'ob_nazev'}->set_text($Osoba->get('prijmeni')." ".$Osoba->get('jmeno'));
            $MyUI->FORM->{'ob_ulice'}->set_text($Osoba->get('ulice'));
            $MyUI->FORM->{'ob_psc'}->set_text($Osoba->get('psc'));
            $MyUI->FORM->{'ob_mesto'}->set_text($Osoba->get('mesto'));
            $MyUI->FORM->{'ob_statnazev'}->set_text($Osoba->get('statnazev'));
            $MyUI->FORM->{'ob_statzkrat'}->set_text($Osoba->get('statzkrat'));
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_vyjmout_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>'Opravdu chcete smazat oznacene zaznamy?','type'=>'question')) {
        my @paths=$MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows;
        for(my $j=(@paths-1); $j>=0; $j--) {
            my $path=$paths[$j];
            my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path);
            my $poradi=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,18);
            delete($SeznamOsob[$poradi-1]);
        };
        my @os=();
        foreach my $Osoba (@SeznamOsob) {  
            if(ref($Osoba)) {
                push(@os,$Osoba);
            };
        };
        @SeznamOsob=@os;
        $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('none');
        @{$MyUI->FORM->{'list_osoby'}->{data}}=();
        my $i=1;
        foreach my $Osoba (@SeznamOsob) {
            $Osoba->set('poradi',$i);
            push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$Osoba->get("prijmeni"),$Osoba->get("jmeno"),$Osoba->get("ean"),$Osoba->get("funkce"),$Osoba->get("ulice"),$Osoba->get("mesto"),$Osoba->get("psc"),$Osoba->get("statnazev"),$Osoba->get("telpred"),$Osoba->get("tel"),$Osoba->get("telklap"),$Osoba->get("faxpred"),$Osoba->get("fax"),$Osoba->get("faxklap"),$Osoba->get("email"),$Osoba->get("mobilpred"),$Osoba->get("mobil"),$Osoba->get("id"),$Osoba->get("poradi")]);
            $i++;
        };
        $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('multiple');
        if(@SeznamOsob!=1) {
            $MyUI->FORM->{'firmajeosoba'}->set_active(0);
            $MyUI->FORM->{'firmajeosoba'}->set_sensitive(0);
        } else {
            $MyUI->FORM->{'firmajeosoba'}->set_sensitive(1);
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_kopirovat_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
    my @path=$MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path[0]);
    my $id=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,17);
    my $poradi=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,18);
    my $retval=0;
    foreach my $Osoba (@SeznamOsob) {
        if($Osoba->get('poradi') eq $poradi) {
            $retval=$KartaKontaktniOsoby->upravit_novy(1,"id='".$id."'",$Osoba,%MyMoney);
        };
    };
    if($retval) {
        my $i=0;
        my $poradi=@SeznamOsob;
        $poradi++;
        $retval->set('poradi',$poradi);
        $retval->set('id',0);
        push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$retval->get("prijmeni"),$retval->get("jmeno"),$retval->get("ean"),$retval->get("funkce"),$retval->get("ulice"),$retval->get("mesto"),$retval->get("psc"),$retval->get("statnazev"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("mobilpred"),$retval->get("mobil"),$retval->get("id"),$retval->get("poradi")]);
        push(@SeznamOsob,$retval);
        if(@SeznamOsob!=1) {
            $MyUI->FORM->{'firmajeosoba'}->set_active(0);
            $MyUI->FORM->{'firmajeosoba'}->set_sensitive(0);
        } else {
            $MyUI->FORM->{'firmajeosoba'}->set_sensitive(1);
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_opravit_clicked {
    $MyUI->upravit_osobu;
};

sub osoby_selection_changed {
    if($MyUI->FORM->{'list_osoby'}->get_selection->count_selected_rows!=1) {
        $MyUI->FORM->{'button_opravit'}->set_sensitive(0);
        $MyUI->FORM->{'button_kopirovat'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'button_opravit'}->set_sensitive(1);
        if((!$MyUI->{'dissable_ok'}) && (!$MyUI->FORM->{'firmajeosoba'}->get_active)) {
            $MyUI->FORM->{'button_kopirovat'}->set_sensitive(1);
        } else {
            $MyUI->FORM->{'button_kopirovat'}->set_sensitive(0);
        };
    };
    if($MyUI->FORM->{'list_osoby'}->get_selection->count_selected_rows==0) {
        $MyUI->FORM->{'button_vyjmout'}->set_sensitive(0);
    } else {
        if((!$MyUI->{'dissable_ok'}) && (!$MyUI->FORM->{'firmajeosoba'}->get_active)) {
            $MyUI->FORM->{'button_vyjmout'}->set_sensitive(1);
        } else {
            $MyUI->FORM->{'button_vyjmout'}->set_sensitive(0);
        };
    };
    if(($MyUI->{'dissable_ok'}) || ($MyUI->FORM->{'firmajeosoba'}->get_active)) {
        $MyUI->FORM->{'button_pridat'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'button_pridat'}->set_sensitive(1);
    };
};

sub on_firmajeosoba_toggled {
    if($MyUI->FORM->{'firmajeosoba'}->get_active) {
        if((($MyUI->FORM->{'ob_nazev'}->get_text) || 
                ($MyUI->FORM->{'ob_ulice'}->get_text) || 
                ($MyUI->FORM->{'ob_psc'}->get_text) || 
                ($MyUI->FORM->{'ob_mesto'}->get_text) || 
                ($MyUI->FORM->{'ob_statnazev'}->get_text) || 
                ($MyUI->FORM->{'ob_statzkrat'}->get_text)) && 
                (!$in_init)) {
            my $Dialog=new Dialog(%MyMoney);
            if(!$Dialog->show("text"=>"Adresa firmy je jiz vyplnena, skutecne chcete kontaktni osobu prevest do nazvu firmy?","type"=>"question")) {
                $MyUI->FORM->{'firmajeosoba'}->set_active(0);
                return;
            };
            if(@SeznamOsob) {
                my $Osoba=$SeznamOsob[0];
                $MyUI->FORM->{'ob_nazev'}->set_text($Osoba->get('prijmeni')." ".$Osoba->get('jmeno'));
                $MyUI->FORM->{'ob_ulice'}->set_text($Osoba->get('ulice'));
                $MyUI->FORM->{'ob_psc'}->set_text($Osoba->get('psc'));
                $MyUI->FORM->{'ob_mesto'}->set_text($Osoba->get('mesto'));
                $MyUI->FORM->{'ob_statnazev'}->set_text($Osoba->get('statnazev'));
                $MyUI->FORM->{'ob_statzkrat'}->set_text($Osoba->get('statzkrat'));
            };
        };
        $MyUI->FORM->{'ob_nazev'}->set_sensitive(0);
        $MyUI->FORM->{'ob_ulice'}->set_sensitive(0);
        $MyUI->FORM->{'ob_psc'}->set_sensitive(0);
        $MyUI->FORM->{'ob_mesto'}->set_sensitive(0);
        $MyUI->FORM->{'ob_statnazev'}->set_sensitive(0);
        $MyUI->FORM->{'ob_statzkrat'}->set_sensitive(0);
        $MyUI->FORM->{'button_obpsc'}->set_sensitive(0);
        $MyUI->FORM->{'button_obstat'}->set_sensitive(0);
    } else {
        $MyUI->FORM->{'ob_nazev'}->set_sensitive(1);
        $MyUI->FORM->{'ob_ulice'}->set_sensitive(1);
        $MyUI->FORM->{'ob_psc'}->set_sensitive(1);
        $MyUI->FORM->{'ob_mesto'}->set_sensitive(1);
        $MyUI->FORM->{'ob_statnazev'}->set_sensitive(1);
        $MyUI->FORM->{'ob_statzkrat'}->set_sensitive(1);
        $MyUI->FORM->{'button_obpsc'}->set_sensitive(1);
        $MyUI->FORM->{'button_obstat'}->set_sensitive(1);
    };
    $MyUI->osoby_selection_changed;
};

1;
