#!/usr/bin/perl -w

package KorekceFaktury;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::_DanovaKalkulacka;

my $MyUI;
my %MyMoney;
my $retcode="";
my %values;
my $dissable_changes=0;

sub run {
    my ($class, %params) = @_;
    $retcode=0;
    
    %values=%params;
    %MyMoney=@{$params{'cfg'}};
    
    my $window=$class;
    $MyUI=$class;

    $MyUI->FORM->{'zaokr_dph'}->set_history($values{'zaokr_dph'});
    $MyUI->FORM->{'zaokr_dph_m'}->set_history($values{'zaokr_dph_m'});
    $MyUI->FORM->{'zaokr_celk'}->set_history($values{'zaokr_celk'});
    $MyUI->FORM->{'zaokr_celk_m'}->set_history($values{'zaokr_celk_m'});
    $MyUI->FORM->{'zaokr_rozpoustet'}->set_history($values{'zaokr_rozpoustet'});

    $MyUI->FORM->{'_danova_kalkulacka1'}=new _DanovaKalkulacka;
    $MyUI->FORM->{'_danova_kalkulacka1'}->init;
    $MyUI->FORM->{'_danova_kalkulacka1'}->reparent($window->FORM->{'hbox492'});
    $MyUI->FORM->{'_danova_kalkulacka1'}->show;
    $MyUI->FORM->{'_danova_kalkulacka1'}->set_editable(0);
    $MyUI->FORM->{'_danova_kalkulacka1'}->set_sazbydph($values{'sazbadph1'},$values{'sazbadph2'});
    $MyUI->FORM->{'_danova_kalkulacka1'}->set_value('z0',$values{'zaklad_0'});
    $MyUI->FORM->{'_danova_kalkulacka1'}->set_value('z1',$values{'zaklad_1'});
    $MyUI->FORM->{'_danova_kalkulacka1'}->set_value('z2',$values{'zaklad_2'});
    
    $MyUI->FORM->{'_danova_kalkulacka2'}=new _DanovaKalkulacka;
    $MyUI->FORM->{'_danova_kalkulacka2'}->init;
    $MyUI->FORM->{'_danova_kalkulacka2'}->reparent($window->FORM->{'hbox510'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->show;
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_editable(0);
    $MyUI->FORM->{'_danova_kalkulacka2'}->freeze;
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_sazbydph($values{'sazbadph1'},$values{'sazbadph2'});
    #$MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z0',$values{'kzaklad_0'});
    #$MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z1',$values{'kzaklad_1'});
    #$MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z2',$values{'kzaklad_2'});

    $MyUI->FORM->{'_danova_kalkulacka3'}=new _DanovaKalkulacka;
    $MyUI->FORM->{'_danova_kalkulacka3'}->init;
    $MyUI->FORM->{'_danova_kalkulacka3'}->reparent($window->FORM->{'hbox608'});
    $MyUI->FORM->{'_danova_kalkulacka3'}->show;
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_editable(1);
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_sazbydph($values{'sazbadph1'},$values{'sazbadph2'});
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_zaokrouhleni_dph($MyUI->FORM->{'zaokr_dph'}->get_history,$MyUI->FORM->{'zaokr_dph_m'}->get_history);
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_zaokrouhleni_ceny_celkem($MyUI->FORM->{'zaokr_celk'}->get_history,$MyUI->FORM->{'zaokr_celk_m'}->get_history,$MyUI->FORM->{'zaokr_rozpoustet'}->get_history);
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_value('z0',$values{'zaklad_0'}+$values{'kzaklad_0'});
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_value('z1',$values{'zaklad_1'}+$values{'kzaklad_1'});
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_value('z2',$values{'zaklad_2'}+$values{'kzaklad_2'});
    $MyUI->FORM->{'_danova_kalkulacka3'}->signal_connect("vcdph3_changed","KorekceFaktury::celkova_cena_changed",$MyUI);

    if($MyMoney{'RokData'}->get('platce_dph')) {
        $MyUI->FORM->{'_danova_kalkulacka1'}->show_dph(1);
        $MyUI->FORM->{'_danova_kalkulacka2'}->show_dph(1);
        $MyUI->FORM->{'_danova_kalkulacka3'}->show_dph(1);
    } else {
        $MyUI->FORM->{'_danova_kalkulacka1'}->show_dph(0);
        $MyUI->FORM->{'_danova_kalkulacka2'}->show_dph(0);
        $MyUI->FORM->{'_danova_kalkulacka3'}->show_dph(0);
    };

    $MyUI->celkova_cena_changed;
    
    $window->TOPLEVEL->set_title('Uprava cen vystavene faktury');
    $MyMoney{'MainCfg'}->window_open("KorekceFaktury",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    $MyMoney{'MainCfg'}->window_close("KorekceFaktury",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_KorekceFaktury_unrealize {
    $MyMoney{'MainCfg'}->window_close("KorekceFaktury",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $MyMoney{'MainCfg'}->window_close("KorekceFaktury",$MyUI->TOPLEVEL);
    $values{'zaokr_dph'}=$MyUI->FORM->{'zaokr_dph'}->get_history;
    $values{'zaokr_dph_m'}=$MyUI->FORM->{'zaokr_dph_m'}->get_history;
    $values{'zaokr_celk'}=$MyUI->FORM->{'zaokr_celk'}->get_history;
    $values{'zaokr_celk_m'}=$MyUI->FORM->{'zaokr_celk_m'}->get_history;
    $values{'zaokr_rozpoustet'}=$MyUI->FORM->{'zaokr_rozpoustet'}->get_history;
    $retcode=1;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub celkova_cena_changed {
    $values{'kzaklad_0'}=$MyUI->FORM->{'_danova_kalkulacka3'}->get_value('z0')-$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('z0');
    $values{'kzaklad_1'}=$MyUI->FORM->{'_danova_kalkulacka3'}->get_value('z1')-$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('z1');
    $values{'kzaklad_2'}=$MyUI->FORM->{'_danova_kalkulacka3'}->get_value('z2')-$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('z2');
    $values{'kdph_1'}=$MyUI->FORM->{'_danova_kalkulacka3'}->get_value('dph1')-$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('dph1');
    $values{'kdph_2'}=$MyUI->FORM->{'_danova_kalkulacka3'}->get_value('dph2')-$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('dph2');

    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z0',$values{'kzaklad_0'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z1',$values{'kzaklad_1'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z2',$values{'kzaklad_2'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('z3',$values{'kzaklad_0'}+$values{'kzaklad_1'}+$values{'kzaklad_2'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('dph1',$values{'kdph_1'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('dph2',$values{'kdph_2'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('dph3',$values{'kdph_1'}+$values{'kdph_2'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('vcdph0',$values{'kzaklad_0'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('vcdph1',$values{'kzaklad_1'}+$values{'kdph_1'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('vcdph2',$values{'kzaklad_2'}+$values{'kdph_2'});
    $MyUI->FORM->{'_danova_kalkulacka2'}->set_value('vcdph3',$values{'kzaklad_0'}+$values{'kzaklad_1'}+$values{'kzaklad_2'}+$values{'kdph_1'}+$values{'kdph_2'});

    if($values{'kzaklad_0'} || $values{'kzaklad_1'} || $values{'kzaklad_2'} || $values{'kdph_1'} || $values{'kdph_2'}) {
        $MyUI->FORM->{'korekce_nastavena'}->set_active(1);
    } else {
        $MyUI->FORM->{'korekce_nastavena'}->set_active(0);
    };
};


sub on_button_zrusitupravu_clicked {
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_zaokrouhleni_dph(0,0);
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_zaokrouhleni_ceny_celkem(0,0,0);
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_value('z0',$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('z0'));
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_value('z1',$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('z1'));
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_value('z2',$MyUI->FORM->{'_danova_kalkulacka1'}->get_value('z2'));
};

sub on_korekce_nastavena_toggled {
    if($MyUI->FORM->{'korekce_nastavena'}->get_active) {
        $values{'korekce_nastavena'}=1;
    } else {
        $values{'korekce_nastavena'}=0;
    };
};

sub get_values {
    return(%values);
};

sub on_zaokr_changed {
    if($MyUI->FORM->{'zaokr_dph'}->get_history) {
        $MyUI->FORM->{'zaokr_dph_m'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'zaokr_dph_m'}->set_sensitive(0);
    };
    if($MyUI->FORM->{'zaokr_celk'}->get_history) {
        $MyUI->FORM->{'zaokr_celk_m'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'zaokr_celk_m'}->set_sensitive(0);
    };
};

sub on_vypocet_clicked {
    $MyUI->on_button_zrusitupravu_clicked;
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_zaokrouhleni_dph($MyUI->FORM->{'zaokr_dph'}->get_history,$MyUI->FORM->{'zaokr_dph_m'}->get_history);
    $MyUI->FORM->{'_danova_kalkulacka3'}->set_zaokrouhleni_ceny_celkem($MyUI->FORM->{'zaokr_celk'}->get_history,$MyUI->FORM->{'zaokr_celk_m'}->get_history,$MyUI->FORM->{'zaokr_rozpoustet'}->get_history);
    $MyUI->FORM->{'_danova_kalkulacka3'}->zaokrouhleni_celkem;
    $MyUI->FORM->{'_danova_kalkulacka3'}->prepocitat;
    $MyUI->celkova_cena_changed;
};

1;
