#!/usr/bin/perl -w

package PenezniUstav;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $PenezniUstav;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('g_Banky',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    $Locks=0;
    %MyMoney=%params;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('g_Banky',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove('g_Banky',$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    $PenezniUstav=new Table('g_Banky',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$PenezniUstav->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    $PenezniUstav->WriteToUI($window->FORM);
    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Peněžní ústav');
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox142'};
    $MyMoney{'MainCfg'}->window_open("PenezniUstav",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("PenezniUstav",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_PenezniUstav_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("PenezniUstav",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $PenezniUstav->ReadFromUI($MyUI->FORM);
    if(!$PenezniUstav->get('zkrat')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka nemůže být prázdná!","type"=>"error");
            return;        
    };
    if(!$PenezniUstav->get('kod')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Kód nemůže být prázdný!","type"=>"error");
            return;        
    };
    if(!$PenezniUstav->get('nazev')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Název nemůže být prázdný!","type"=>"error");
            return;        
    };

    if($MyUI->{'where'}) {
        if(!$PenezniUstav->update) {
            return;
        };
    } else {
        if(!$PenezniUstav->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("PenezniUstav",$MyUI->TOPLEVEL);
    $retcode=$PenezniUstav;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_kodstatu_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('staty',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"kod","selected_rows"=>[$MyUI->FORM->{'kodstatu'}->get_text])) {
        my $tbl=new Table('g_Staty',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'kodstatu'}->set_text($tbl->get('kod'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'kodstatu'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

1;
